Index: ccr/trunk/rxnorm/trunk/globals/F176.002.ZWR
===================================================================
--- ccr/trunk/rxnorm/trunk/globals/F176.002.ZWR	(revision 1615)
+++ ccr/trunk/rxnorm/trunk/globals/F176.002.ZWR	(revision 1631)
@@ -1,4 +1,4 @@
 KBANXDD - FILE 176.002
-3130409.132457 ZWR
+3131114.151203 ZWR
 ^DIC(176.002,0)="RXNORM SIMPLE CONCEPT AND ATOM ATTRIBUTES^176.002"
 ^DIC(176.002,0,"AUDIT")="@"
@@ -9,5 +9,5 @@
 ^DIC(176.002,0,"RD")=""
 ^DIC(176.002,0,"WR")="@"
-^DIC(176.002,"%",0)="^1.005^^"
+^DIC(176.002,"%",0)="^1.005^^0"
 ^DIC(176.002,"%D",0)="^^9^9^3130301^"
 ^DIC(176.002,"%D",1,0)="File: RXNSAT.RRF"
@@ -21,4 +21,6 @@
 ^DIC(176.002,"%D",9,0)="vocabulary attributes that do not fit into other categories."
 ^DD(176.002,0)="FIELD^^.13^13"
+^DD(176.002,0,"DIK")="C0CRXN2"
+^DD(176.002,0,"DIKOLD")="C0CRXN2"
 ^DD(176.002,0,"DT")=3130301
 ^DD(176.002,0,"ID",.1)="W ""   "",$P(^(0),U,10)"
@@ -143,85 +145,85 @@
 ^DD(176.002,"RQ",.01)=""
 ^DD(176.002,"RQ",.1)=""
-^DD("IX",904,0)="176.002^RXCUI^RXCUI Index^R^^F^IR^I^176.002^^^^^LS"
-^DD("IX",904,1)="S ^C0CRXN(176.002,""RXCUI"",X,DA)="""""
-^DD("IX",904,2)="K ^C0CRXN(176.002,""RXCUI"",X,DA)"
-^DD("IX",904,2.5)="K ^C0CRXN(176.002,""RXCUI"")"
-^DD("IX",904,11.1,0)="^.114IA^1^1"
-^DD("IX",904,11.1,1,0)="1^F^176.002^.09^^1^F"
-^DD("IX",904,11.1,"AC",1,1)=""
-^DD("IX",904,11.1,"B",1,1)=""
-^DD("IX",904,11.1,"BB",1,1)=""
-^DD("IX",910,0)="176.002^ASAA^SAB (Source) ATN (Attribute Name) ATV (Value) Index^MU^^R^IR^I^176.002^^^^^S"
-^DD("IX",910,1)="S ^C0CRXN(176.002,""ASAA"",X(1),$E(X(2),1,30),$E(X(3),1,30),DA)=X(4)"
-^DD("IX",910,2)="K ^C0CRXN(176.002,""ASAA"",X(1),$E(X(2),1,30),$E(X(3),1,30),DA)"
-^DD("IX",910,2.5)="K ^C0CRXN(176.002,""ASAA"")"
-^DD("IX",910,11.1,0)="^.114IA^4^4"
-^DD("IX",910,11.1,1,0)="1^F^176.002^.1^^1^F"
-^DD("IX",910,11.1,1,3)=""
-^DD("IX",910,11.1,2,0)="2^F^176.002^.01^30^2^F"
-^DD("IX",910,11.1,2,3)=""
-^DD("IX",910,11.1,3,0)="3^F^176.002^.11^30^3^F"
-^DD("IX",910,11.1,3,3)=""
-^DD("IX",910,11.1,4,0)="4^F^176.002^.09^^^F"
-^DD("IX",910,11.1,4,3)=""
-^DD("IX",910,11.1,"AC",1,1)=""
-^DD("IX",910,11.1,"AC",2,2)=""
-^DD("IX",910,11.1,"AC",3,3)=""
-^DD("IX",910,11.1,"B",1,1)=""
-^DD("IX",910,11.1,"B",2,2)=""
-^DD("IX",910,11.1,"B",3,3)=""
-^DD("IX",910,11.1,"B",4,4)=""
-^DD("IX",910,11.1,"BB",1,1)=""
-^DD("IX",910,11.1,"BB",2,2)=""
-^DD("IX",910,11.1,"BB",3,3)=""
-^DD("IX",910,11.1,"BB",4,4)=""
-^DD("IX",911,0)="176.002^ASAR^SAB (Source) ATN (Attribute Name) RxCUI Index^MU^^R^IR^I^176.002^^^^^S"
-^DD("IX",911,1)="S ^C0CRXN(176.002,""ASAR"",X(1),$E(X(2),1,30),X(3),DA)=X(4)"
-^DD("IX",911,2)="K ^C0CRXN(176.002,""ASAR"",X(1),$E(X(2),1,30),X(3),DA)"
-^DD("IX",911,2.5)="K ^C0CRXN(176.002,""ASAR"")"
-^DD("IX",911,11.1,0)="^.114IA^4^4"
-^DD("IX",911,11.1,1,0)="1^F^176.002^.1^^1^F"
-^DD("IX",911,11.1,1,3)=""
-^DD("IX",911,11.1,2,0)="2^F^176.002^.01^30^2^F"
-^DD("IX",911,11.1,2,3)=""
-^DD("IX",911,11.1,3,0)="3^F^176.002^.09^^3^F"
-^DD("IX",911,11.1,3,3)=""
-^DD("IX",911,11.1,4,0)="4^F^176.002^.11^^^F"
-^DD("IX",911,11.1,4,3)=""
-^DD("IX",911,11.1,"AC",1,1)=""
-^DD("IX",911,11.1,"AC",2,2)=""
-^DD("IX",911,11.1,"AC",3,3)=""
-^DD("IX",911,11.1,"B",1,1)=""
-^DD("IX",911,11.1,"B",2,2)=""
-^DD("IX",911,11.1,"B",3,3)=""
-^DD("IX",911,11.1,"B",4,4)=""
-^DD("IX",911,11.1,"BB",1,1)=""
-^DD("IX",911,11.1,"BB",2,2)=""
-^DD("IX",911,11.1,"BB",3,3)=""
-^DD("IX",911,11.1,"BB",4,4)=""
-^DD("IX",912,0)="176.002^ANDFRT^RxNorm NDFRT Index^R^^R^IR^I^176.002^^^^^S"
-^DD("IX",912,1)="S ^C0CRXN(176.002,""ANDFRT"",X(1),$E(X(3),1,30),$E(X(4),1,30),DA)="""""
-^DD("IX",912,1.4)="S X=X(2)=""NDFRT"""
-^DD("IX",912,2)="K ^C0CRXN(176.002,""ANDFRT"",X(1),$E(X(3),1,30),$E(X(4),1,30),DA)"
-^DD("IX",912,2.4)="S X=X(2)=""NDFRT"""
-^DD("IX",912,2.5)="K ^C0CRXN(176.002,""ANDFRT"")"
-^DD("IX",912,11.1,0)="^.114IA^4^4"
-^DD("IX",912,11.1,1,0)="1^F^176.002^.09^^1^F"
-^DD("IX",912,11.1,1,3)=""
-^DD("IX",912,11.1,2,0)="2^F^176.002^.1^^^F"
-^DD("IX",912,11.1,2,3)=""
-^DD("IX",912,11.1,3,0)="3^F^176.002^.01^30^2^F"
-^DD("IX",912,11.1,3,3)=""
-^DD("IX",912,11.1,4,0)="4^F^176.002^.11^30^3^F"
-^DD("IX",912,11.1,4,3)=""
-^DD("IX",912,11.1,"AC",1,1)=""
-^DD("IX",912,11.1,"AC",2,3)=""
-^DD("IX",912,11.1,"AC",3,4)=""
-^DD("IX",912,11.1,"B",1,1)=""
-^DD("IX",912,11.1,"B",2,2)=""
-^DD("IX",912,11.1,"B",3,3)=""
-^DD("IX",912,11.1,"B",4,4)=""
-^DD("IX",912,11.1,"BB",1,1)=""
-^DD("IX",912,11.1,"BB",2,2)=""
-^DD("IX",912,11.1,"BB",3,3)=""
-^DD("IX",912,11.1,"BB",4,4)=""
+^DD("IX",1024,0)="176.002^ANDFRT^RxNorm NDFRT Index^R^^R^IR^I^176.002^^^^^S"
+^DD("IX",1024,1)="S ^C0CRXN(176.002,""ANDFRT"",X(1),$E(X(3),1,30),$E(X(4),1,30),DA)="""""
+^DD("IX",1024,1.4)="S X=X(2)=""NDFRT"""
+^DD("IX",1024,2)="K ^C0CRXN(176.002,""ANDFRT"",X(1),$E(X(3),1,30),$E(X(4),1,30),DA)"
+^DD("IX",1024,2.4)="S X=X(2)=""NDFRT"""
+^DD("IX",1024,2.5)="K ^C0CRXN(176.002,""ANDFRT"")"
+^DD("IX",1024,11.1,0)="^.114IA^4^4"
+^DD("IX",1024,11.1,1,0)="1^F^176.002^.09^^1^F"
+^DD("IX",1024,11.1,1,3)=""
+^DD("IX",1024,11.1,2,0)="2^F^176.002^.1^^^F"
+^DD("IX",1024,11.1,2,3)=""
+^DD("IX",1024,11.1,3,0)="3^F^176.002^.01^30^2^F"
+^DD("IX",1024,11.1,3,3)=""
+^DD("IX",1024,11.1,4,0)="4^F^176.002^.11^30^3^F"
+^DD("IX",1024,11.1,4,3)=""
+^DD("IX",1024,11.1,"AC",1,1)=""
+^DD("IX",1024,11.1,"AC",2,3)=""
+^DD("IX",1024,11.1,"AC",3,4)=""
+^DD("IX",1024,11.1,"B",1,1)=""
+^DD("IX",1024,11.1,"B",2,2)=""
+^DD("IX",1024,11.1,"B",3,3)=""
+^DD("IX",1024,11.1,"B",4,4)=""
+^DD("IX",1024,11.1,"BB",1,1)=""
+^DD("IX",1024,11.1,"BB",2,2)=""
+^DD("IX",1024,11.1,"BB",3,3)=""
+^DD("IX",1024,11.1,"BB",4,4)=""
+^DD("IX",1025,0)="176.002^ASAA^SAB (Source) ATN (Attribute Name) ATV (Value) Index^MU^^R^IR^I^176.002^^^^^S"
+^DD("IX",1025,1)="S ^C0CRXN(176.002,""ASAA"",X(1),$E(X(2),1,30),$E(X(3),1,30),DA)=X(4)"
+^DD("IX",1025,2)="K ^C0CRXN(176.002,""ASAA"",X(1),$E(X(2),1,30),$E(X(3),1,30),DA)"
+^DD("IX",1025,2.5)="K ^C0CRXN(176.002,""ASAA"")"
+^DD("IX",1025,11.1,0)="^.114IA^4^4"
+^DD("IX",1025,11.1,1,0)="1^F^176.002^.1^^1^F"
+^DD("IX",1025,11.1,1,3)=""
+^DD("IX",1025,11.1,2,0)="2^F^176.002^.01^30^2^F"
+^DD("IX",1025,11.1,2,3)=""
+^DD("IX",1025,11.1,3,0)="3^F^176.002^.11^30^3^F"
+^DD("IX",1025,11.1,3,3)=""
+^DD("IX",1025,11.1,4,0)="4^F^176.002^.09^^^F"
+^DD("IX",1025,11.1,4,3)=""
+^DD("IX",1025,11.1,"AC",1,1)=""
+^DD("IX",1025,11.1,"AC",2,2)=""
+^DD("IX",1025,11.1,"AC",3,3)=""
+^DD("IX",1025,11.1,"B",1,1)=""
+^DD("IX",1025,11.1,"B",2,2)=""
+^DD("IX",1025,11.1,"B",3,3)=""
+^DD("IX",1025,11.1,"B",4,4)=""
+^DD("IX",1025,11.1,"BB",1,1)=""
+^DD("IX",1025,11.1,"BB",2,2)=""
+^DD("IX",1025,11.1,"BB",3,3)=""
+^DD("IX",1025,11.1,"BB",4,4)=""
+^DD("IX",1026,0)="176.002^ASAR^SAB (Source) ATN (Attribute Name) RxCUI Index^MU^^R^IR^I^176.002^^^^^S"
+^DD("IX",1026,1)="S ^C0CRXN(176.002,""ASAR"",X(1),$E(X(2),1,30),X(3),DA)=X(4)"
+^DD("IX",1026,2)="K ^C0CRXN(176.002,""ASAR"",X(1),$E(X(2),1,30),X(3),DA)"
+^DD("IX",1026,2.5)="K ^C0CRXN(176.002,""ASAR"")"
+^DD("IX",1026,11.1,0)="^.114IA^4^4"
+^DD("IX",1026,11.1,1,0)="1^F^176.002^.1^^1^F"
+^DD("IX",1026,11.1,1,3)=""
+^DD("IX",1026,11.1,2,0)="2^F^176.002^.01^30^2^F"
+^DD("IX",1026,11.1,2,3)=""
+^DD("IX",1026,11.1,3,0)="3^F^176.002^.09^^3^F"
+^DD("IX",1026,11.1,3,3)=""
+^DD("IX",1026,11.1,4,0)="4^F^176.002^.11^^^F"
+^DD("IX",1026,11.1,4,3)=""
+^DD("IX",1026,11.1,"AC",1,1)=""
+^DD("IX",1026,11.1,"AC",2,2)=""
+^DD("IX",1026,11.1,"AC",3,3)=""
+^DD("IX",1026,11.1,"B",1,1)=""
+^DD("IX",1026,11.1,"B",2,2)=""
+^DD("IX",1026,11.1,"B",3,3)=""
+^DD("IX",1026,11.1,"B",4,4)=""
+^DD("IX",1026,11.1,"BB",1,1)=""
+^DD("IX",1026,11.1,"BB",2,2)=""
+^DD("IX",1026,11.1,"BB",3,3)=""
+^DD("IX",1026,11.1,"BB",4,4)=""
+^DD("IX",1027,0)="176.002^RXCUI^RXCUI Index^R^^F^IR^I^176.002^^^^^LS"
+^DD("IX",1027,1)="S ^C0CRXN(176.002,""RXCUI"",X,DA)="""""
+^DD("IX",1027,2)="K ^C0CRXN(176.002,""RXCUI"",X,DA)"
+^DD("IX",1027,2.5)="K ^C0CRXN(176.002,""RXCUI"")"
+^DD("IX",1027,11.1,0)="^.114IA^1^1"
+^DD("IX",1027,11.1,1,0)="1^F^176.002^.09^^1^F"
+^DD("IX",1027,11.1,"AC",1,1)=""
+^DD("IX",1027,11.1,"B",1,1)=""
+^DD("IX",1027,11.1,"BB",1,1)=""