Index: cprs/branches/HealthSevak-CPRS/CPRS-Chart/Consults/fConsults.dfm
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Chart/Consults/fConsults.dfm	(revision 1693)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Chart/Consults/fConsults.dfm	(revision 1698)
@@ -4,5 +4,5 @@
   HelpContext = 6000
   Caption = 'Consults Page'
-  ClientHeight = 421
+  ClientHeight = 501
   ClientWidth = 715
   Menu = mnuConsults
@@ -11,9 +11,9 @@
   OnShow = FormShow
   ExplicitWidth = 723
-  ExplicitHeight = 475
+  ExplicitHeight = 555
   PixelsPerInch = 96
   TextHeight = 13
   inherited shpPageBottom: TShape
-    Top = 416
+    Top = 496
     Width = 715
     ExplicitTop = 416
@@ -23,5 +23,5 @@
     Left = 83
     Width = 2
-    Height = 416
+    Height = 496
     OnCanResize = sptHorzCanResize
     ExplicitLeft = 83
@@ -32,17 +32,18 @@
     Left = 85
     Width = 630
-    Height = 416
+    Height = 496
     OnExit = pnlRightExit
     OnResize = pnlRightResize
     ExplicitLeft = 85
     ExplicitWidth = 630
-    ExplicitHeight = 416
+    ExplicitHeight = 476
     object sptVert: TSplitter
       Left = 0
-      Top = 350
+      Top = 430
       Width = 630
       Height = 4
       Cursor = crVSplit
       Align = alBottom
+      ExplicitTop = 350
     end
     object pnlRead: TPanel
@@ -50,8 +51,9 @@
       Top = 0
       Width = 630
-      Height = 350
+      Height = 430
       Align = alClient
       BevelOuter = bvNone
       TabOrder = 0
+      ExplicitHeight = 410
       object lblTitle: TOROffsetLabel
         Left = 0
@@ -78,5 +80,5 @@
         Top = 19
         Width = 630
-        Height = 331
+        Height = 411
         Align = alClient
         Color = clCream
@@ -100,9 +102,10 @@
         WantReturns = False
         WordWrap = False
+        ExplicitHeight = 391
       end
     end
     object memPCEShow: TRichEdit
       Left = 0
-      Top = 354
+      Top = 434
       Width = 630
       Height = 62
@@ -111,4 +114,5 @@
       TabOrder = 2
       WantReturns = False
+      ExplicitTop = 414
     end
     object pnlResults: TPanel
@@ -116,14 +120,15 @@
       Top = 0
       Width = 630
-      Height = 350
+      Height = 430
       Align = alClient
       BevelOuter = bvNone
       TabOrder = 1
       OnResize = pnlResultsResize
+      ExplicitHeight = 410
       object memResults: TRichEdit
         Left = 0
         Top = 67
         Width = 630
-        Height = 283
+        Height = 363
         Align = alClient
         Font.Charset = ANSI_CHARSET
@@ -139,4 +144,5 @@
         OnChange = memResultChange
         OnKeyDown = memResultsKeyDown
+        ExplicitHeight = 343
       end
       object pnlFields: TPanel
@@ -266,9 +272,9 @@
   inherited pnlLeft: TPanel [3]
     Width = 83
-    Height = 416
+    Height = 496
     OnExit = pnlLeftExit
     OnResize = pnlLeftResize
     ExplicitWidth = 83
-    ExplicitHeight = 416
+    ExplicitHeight = 476
     object splConsults: TSplitter
       Left = 0
@@ -283,15 +289,17 @@
       Top = 164
       Width = 83
-      Height = 231
+      Height = 311
       Align = alClient
       BevelOuter = bvNone
       TabOrder = 1
+      ExplicitHeight = 291
       object splDrawers: TSplitter
         Left = 0
-        Top = 228
+        Top = 308
         Width = 83
         Height = 3
         Cursor = crVSplit
         Align = alBottom
+        ExplicitTop = 228
       end
       object cmdNewConsult: TORAlignButton
@@ -360,5 +368,5 @@
         Top = 63
         Width = 83
-        Height = 165
+        Height = 245
         Align = alClient
         Constraints.MinWidth = 30
@@ -379,9 +387,10 @@
         Caption = 'Consult Notes'
         NodePiece = 0
+        ExplicitHeight = 225
       end
     end
     object cmdPCE: TORAlignButton
       Left = 0
-      Top = 395
+      Top = 475
       Width = 83
       Height = 21
@@ -392,4 +401,5 @@
       Visible = False
       OnClick = cmdPCEClick
+      ExplicitTop = 455
     end
     object pnlConsultList: TPanel
@@ -540,5 +550,5 @@
         'Status = stsDefault'))
   end
-  object popNoteMemo: TPopupMenu
+  object popNoteMemo: TPopupMenu [5]
     OnPopup = popNoteMemoPopup
     Left = 589
@@ -594,6 +604,11 @@
       OnClick = popNoteMemoGrammarClick
     end
+    object popNoteMemoSpellOpenSource: TMenuItem
+      Caption = 'Chec&k Spelling (OpenSource based)'
+      ShortCut = 118
+      OnClick = popNoteMemoSpellClick
+    end
     object popNoteMemoSpell: TMenuItem
-      Caption = 'C&heck Spelling'
+      Caption = 'C&heck Spelling (MS Office based)'
       OnClick = popNoteMemoSpellClick
     end
@@ -667,5 +682,5 @@
     end
   end
-  object popConsultList: TPopupMenu
+  object popConsultList: TPopupMenu [6]
     Left = 523
     Top = 308
@@ -696,5 +711,5 @@
     end
   end
-  object mnuConsults: TMainMenu
+  object mnuConsults: TMainMenu [7]
     Left = 461
     Top = 305
@@ -1080,5 +1095,5 @@
     end
   end
-  object timAutoSave: TTimer
+  object timAutoSave: TTimer [8]
     Enabled = False
     Interval = 300000
@@ -1087,5 +1102,5 @@
     Top = 110
   end
-  object popNoteList: TPopupMenu
+  object popNoteList: TPopupMenu [9]
     OnPopup = popNoteListPopup
     Left = 395
@@ -1123,5 +1138,5 @@
     end
   end
-  object dlgFindText: TFindDialog
+  object dlgFindText: TFindDialog [10]
     Options = [frDown, frHideUpDown]
     OnFind = dlgFindTextFind
@@ -1129,5 +1144,5 @@
     Top = 303
   end
-  object dlgReplaceText: TReplaceDialog
+  object dlgReplaceText: TReplaceDialog [11]
     OnFind = dlgReplaceTextFind
     OnReplace = dlgReplaceTextReplace
@@ -1135,5 +1150,5 @@
     Top = 303
   end
-  object imgLblNotes: TVA508ImageListLabeler
+  object imgLblNotes: TVA508ImageListLabeler [12]
     Components = <
       item
@@ -1145,5 +1160,5 @@
     Top = 48
   end
-  object imgLblImages: TVA508ImageListLabeler
+  object imgLblImages: TVA508ImageListLabeler [13]
     Components = <
       item
@@ -1155,5 +1170,5 @@
     Top = 88
   end
-  object imgLblConsults: TVA508ImageListLabeler
+  object imgLblConsults: TVA508ImageListLabeler [14]
     Components = <
       item