Index: cprs/branches/HealthSevak-CPRS/CPRS-Chart/fDCSumm.dfm
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Chart/fDCSumm.dfm	(revision 1693)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Chart/fDCSumm.dfm	(revision 1702)
@@ -4,5 +4,5 @@
   HelpContext = 7000
   Caption = 'Discharge Summary Page'
-  ClientHeight = 382
+  ClientHeight = 482
   ClientWidth = 679
   HelpFile = 'overvw'
@@ -10,9 +10,9 @@
   OnDestroy = FormDestroy
   ExplicitWidth = 687
-  ExplicitHeight = 436
+  ExplicitHeight = 536
   PixelsPerInch = 96
   TextHeight = 13
   inherited shpPageBottom: TShape
-    Top = 377
+    Top = 477
     Width = 679
     ExplicitTop = 358
@@ -22,5 +22,5 @@
     Left = 64
     Width = 3
-    Height = 377
+    Height = 477
     OnCanResize = sptHorzCanResize
     ExplicitLeft = 64
@@ -30,7 +30,7 @@
   inherited pnlLeft: TPanel
     Width = 64
-    Height = 377
+    Height = 477
     ExplicitWidth = 64
-    ExplicitHeight = 377
+    ExplicitHeight = 457
     object lblSumms: TOROffsetLabel
       Left = 0
@@ -49,5 +49,5 @@
     object lblSpace1: TLabel
       Left = 0
-      Top = 353
+      Top = 453
       Width = 64
       Height = 3
@@ -59,5 +59,5 @@
     object cmdNewSumm: TORAlignButton
       Left = 0
-      Top = 332
+      Top = 432
       Width = 64
       Height = 21
@@ -66,8 +66,9 @@
       TabOrder = 1
       OnClick = cmdNewSummClick
+      ExplicitTop = 412
     end
     object cmdPCE: TORAlignButton
       Left = 0
-      Top = 356
+      Top = 456
       Width = 64
       Height = 21
@@ -77,4 +78,5 @@
       Visible = False
       OnClick = cmdPCEClick
+      ExplicitTop = 436
     end
     object pnlDrawers: TPanel
@@ -82,11 +84,12 @@
       Top = 19
       Width = 64
-      Height = 313
+      Height = 413
       Align = alClient
       BevelOuter = bvNone
       TabOrder = 0
+      ExplicitHeight = 393
       object splDrawers: TSplitter
         Left = 0
-        Top = 310
+        Top = 410
         Width = 64
         Height = 3
@@ -119,5 +122,5 @@
         Top = 0
         Width = 64
-        Height = 310
+        Height = 410
         Align = alClient
         Constraints.MinWidth = 30
@@ -139,4 +142,5 @@
         NodePiece = 0
         ShortNodeCaptions = True
+        ExplicitHeight = 390
       end
     end
@@ -145,11 +149,11 @@
     Left = 67
     Width = 612
-    Height = 377
+    Height = 477
     ExplicitLeft = 67
     ExplicitWidth = 612
-    ExplicitHeight = 377
+    ExplicitHeight = 457
     object sptVert: TSplitter
       Left = 0
-      Top = 328
+      Top = 428
       Width = 612
       Height = 4
@@ -160,5 +164,5 @@
     object memPCEShow: TRichEdit
       Left = 0
-      Top = 332
+      Top = 432
       Width = 612
       Height = 45
@@ -173,4 +177,5 @@
       WantReturns = False
       WordWrap = False
+      ExplicitTop = 412
     end
     object pnlWrite: TPanel
@@ -178,5 +183,5 @@
       Top = 0
       Width = 612
-      Height = 328
+      Height = 428
       Align = alClient
       BevelOuter = bvNone
@@ -184,9 +189,10 @@
       Visible = False
       OnResize = pnlWriteResize
+      ExplicitHeight = 408
       object memNewSumm: TRichEdit
         Left = 0
         Top = 52
         Width = 612
-        Height = 276
+        Height = 376
         Align = alClient
         Font.Charset = DEFAULT_CHARSET
@@ -204,4 +210,5 @@
         OnChange = memNewSummChange
         OnKeyUp = memNewSummKeyUp
+        ExplicitHeight = 356
       end
       object pnlFields: TORAutoPanel
@@ -318,8 +325,9 @@
       Top = 0
       Width = 612
-      Height = 328
+      Height = 428
       Align = alClient
       BevelOuter = bvNone
       TabOrder = 0
+      ExplicitHeight = 408
       object lblTitle: TOROffsetLabel
         Left = 0
@@ -355,5 +363,5 @@
         Top = 116
         Width = 612
-        Height = 212
+        Height = 312
         Align = alClient
         Color = clCream
@@ -377,4 +385,5 @@
         WantReturns = False
         WordWrap = False
+        ExplicitHeight = 292
       end
       object lvSumms: TCaptionListView
@@ -499,5 +508,5 @@
         'Status = stsDefault'))
   end
-  object mnuSumms: TMainMenu
+  object mnuSumms: TMainMenu [5]
     Left = 596
     Top = 305
@@ -784,5 +793,5 @@
     end
   end
-  object popSummMemo: TPopupMenu
+  object popSummMemo: TPopupMenu [6]
     OnPopup = popSummMemoPopup
     Left = 539
@@ -838,6 +847,11 @@
       OnClick = popSummMemoGrammarClick
     end
+    object popNoteMemoSpellOpenSource: TMenuItem
+      Caption = 'Chec&k Spelling (OpenSource based)'
+      ShortCut = 118
+      OnClick = popSummMemoSpellClick
+    end
     object popSummMemoSpell: TMenuItem
-      Caption = 'C&heck Spelling'
+      Caption = 'C&heck Spelling (MS Office based)'
       OnClick = popSummMemoSpellClick
     end
@@ -899,5 +913,5 @@
     end
   end
-  object popSummList: TPopupMenu
+  object popSummList: TPopupMenu [7]
     OnPopup = popSummListPopup
     Left = 500
@@ -968,5 +982,5 @@
     end
   end
-  object timAutoSave: TTimer
+  object timAutoSave: TTimer [8]
     Enabled = False
     Interval = 300000
@@ -975,5 +989,5 @@
     Top = 61
   end
-  object dlgFindText: TFindDialog
+  object dlgFindText: TFindDialog [9]
     Options = [frDown, frHideUpDown]
     OnFind = dlgFindTextFind
@@ -981,5 +995,5 @@
     Top = 312
   end
-  object dlgReplaceText: TReplaceDialog
+  object dlgReplaceText: TReplaceDialog [10]
     OnFind = dlgReplaceTextFind
     OnReplace = dlgReplaceTextReplace
@@ -987,5 +1001,5 @@
     Top = 313
   end
-  object imgLblNotes: TVA508ImageListLabeler
+  object imgLblNotes: TVA508ImageListLabeler [11]
     Components = <
       item
@@ -1000,5 +1014,5 @@
     Top = 171
   end
-  object imgLblImages: TVA508ImageListLabeler
+  object imgLblImages: TVA508ImageListLabeler [12]
     Components = <
       item